## gpsshogi 0.3.0

=== bin/Makefile ===
GPSSHOGI_HOME = ..
ifdef PROFILE
RELEASE = true
endif

-include makefile.local
include $(GPSSHOGI_HOME)/makefile.conf

#
all:
	$(MAKE) -C $(GPSSHOGI_HOME) update-revision
	$(MAKE) programs
programs: gpsshogi gpsusi alphabetastat 

ifdef PROFILE
PROF = $(PROFILE_FLAGS)
LDFLAGS += $(PROF)
endif

LOADLIBES += -lboost_thread$(BOOST_POSTFIX_MT) -lboost_program_options$(BOOST_POSTFIX) -lpthread

## #gcc
OTHERFLAGS = -pipe $(CPUOPTION)
ifdef DEBUG
CXXOPTFLAGS = -O
OTHERFLAGS += -g -DDEBUG 
else
CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS)
WARNING_FLAGS += $(WARN_INLINE)
ifdef RELEASE
OTHERFLAGS +=  -DNDEBUG
endif
ifndef PROF
CXXOPTFLAGS += -fomit-frame-pointer
endif
endif

CXXFLAGS = $(PROF) $(OTHERFLAGS) $(CXXOPTFLAGS) $(WARNING_FLAGS) $(INCLUDES)

PROGRAM_SRCS = gpsshogi.cc gpsusi.cc alphabetastat.cc brinkmate.cc
SRCS = $(PROGRAM_SRCS) 
OBJS = $(patsubst %.cc,%.o,$(SRCS))

CC = $(CXX)
PROGRAMS = $(PROGRAM_SRCS:.cc=)
OSL_HOME_FLAGS = -DOSL_HOME=\"$(shell dirname `dirname \`pwd\``)/osl\"

gpsone: gpsone.cc gpsone.gcda gpsshogi.cc gpsoneprof
	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_USE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES)
gpsoneprof: gpsone.cc gpsshogi.cc
	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_GENERATE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES)
gpsone-static: gpsone.cc gpsshogi.cc
	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC)  $(LOADLIBES)

gpsusione: gpsusione.cc gpsusione.gcda gpsusi.cc gpsusioneprof
	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_USE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES)
gpsusioneprof: gpsusione.cc gpsusi.cc
	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_GENERATE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES)
gpsusione-static: gpsusione.cc gpsusi.cc
	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC)  $(LOADLIBES)

run-profile: gpsoneprof
	./gpsoneprof -e test --benchmark-more=16 -B45	
run-profile-mp: gpsoneprof
	./gpsoneprof -e test --benchmark-more=16 -B45 -N1
update-gpsone:
	-rm gpsoneprof gpsone gpsone.gcda 
	$(MAKE) gpsoneprof RELEASE=t
	$(MAKE) run-profile
	$(MAKE) gpsone RELEASE=t
update-gpsone-mp:
	-rm gpsoneprof gpsone gpsone.gcda 
	$(MAKE) gpsoneprof RELEASE=t
	$(MAKE) run-profile-mp
	$(MAKE) gpsone RELEASE=t

run-profile-usi: gpsusioneprof
	./gpsusioneprof --profile --benchmark-more=16 --benchmark-seconds=45
update-gpsusione:
	-rm gpsusioneprof gpsusione gpsusione.gcda 
	$(MAKE) gpsusioneprof RELEASE=t
	$(MAKE) run-profile-usi
	$(MAKE) gpsusione RELEASE=t

gpsusi gpsshogi alphabetastat brinkmate: $(FILE_OSL_ALL)

clean:
	-rm *.o $(PROGRAMS)
	-rm -rf .deps

light-clean:
	-rm -rf .deps .objs .gch 

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

.PHONY: all clean light-clean run-profile run-profile-mp run-profile-usi update-gpsusione

=== sample/checkeval/Makefile ===
GPSSHOGI_HOME = ../..
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

# type make RELEASE=yes to build optimized programs
# type make DEBUG=yes to build programs for debugging

LDFLAGS +=  -L$(OSL_LIB_DIR)
LOADLIBES = -losl -lm 

ifeq ($(CXX),icc)
INCLUDES += -I/usr/local/include
OTHERFLAGS = -w1
ifndef RELEASE
CXXOPTFLAGS = -O
OTHERFLAGS +=  -DDEBUG
else
CXXOPTFLAGS = -O3
OTHERFLAGS += -wp_ipo -ipo_obj -unroll8 -DNDEBUG
#PROF = -prof_use
endif
LDFLAGS +=  -L/opt/intel/compiler70/ia32/lib
else
OTHERFLAGS = -pipe -Wall $(CPUOPTION)
ifdef PROFILE
PROF = -g -pg
endif
ifdef DEBUG
CXXOPTFLAGS = -O0
OTHERFLAGS += -g -DDEBUG -DCHECKMATE_DEBUG
else
CXXOPTFLAGS = -O2 
OTHERFLAGS += -frename-registers -funroll-loops -finline-limit=12000
ifndef PROF
OTHERFLAGS += -fomit-frame-pointer
endif
ifdef RELEASE
CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS)
OTHERFLAGS += -DNDEBUG
endif
endif
LDFLAGS +=  -L$(CXX_HOME)/lib -Wl,-rpath,$(CXX_HOME)/lib
endif

LDFLAGS += $(PROF)

CXXFLAGS =  $(PROF) $(OTHERFLAGS) $(CXXOPTFLAGS) $(INCLUDES) $(ADDITIONALFLAGS)

SRCS = evalrecord.cc analyzerecord.cc extract.cc checkstat.cc learn.cc \
	evalpositions.cc
# analyze_cost.cc

OBJS = $(SRCS:.cc=.o)
PROGRAMS = $(SRCS:.cc=)
CC = $(CXX)

# CC, LDFLAGS, LOADLIBES Ƥ
# %.o  % 򾡼˺äƤΤ
# ̤ʤΰʳϽɬפʤ

all: $(OBJS) $(PROGRAMS)
$(PROGRAMS): $(OSL_LIB_DIR)/libosl.a 

clean: 
	rm -f core *.o $(PROGNAME) nohup.out *~
distclean: clean 
	rm -f *~

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

KIF_FILE = ../../data/kisen/01.kif

### ¸
# (1)  (proof, disproof)򽸤
pdp2-20.txt:
	time ./evalrecord -N 2 -l 20 -k $(KIF_FILE) -o $@
pdp40k-20.txt:
	time ./evalrecord -N 40000 -l 20 -k $(KIF_FILE) -o $@
pdp40k-10.txt:
	time ./evalrecord -N 40000 -l 10 -k $(KIF_FILE) -o $@
pdp40k-40.txt:
	time ./evalrecord -N 40000 -l 40 -k $(KIF_FILE) -o $@
# (2) ʲfitting ǡ

# (3) 
pdp40k80k-40.txt:
	time ./evalrecord -F 40000 -N 40000 -l 40 -k $(KIF_FILE) -o $@

=== sample/gpsshell/Makefile ===
GPSSHOGI_HOME = ../..
-include makefile.local
include $(GPSSHOGI_HOME)/makefile.conf

#

ifdef PROFILE
PROF = -pg -g
LDFLAGS += $(PROF)
endif


ifeq ($(USE_TOKYO_CABINET),1)
LOADLIBES += -ltokyocabinet $(OSL_HOME)/lib/third_party/$(PROTOBUF)/src/.libs/libprotobuf.a
endif
LOADLIBES += -lboost_thread$(BOOST_POSTFIX_MT) -lboost_program_options$(BOOST_POSTFIX_MT) \
	     -lPocoNet -lPocoFoundation -lreadline -lncurses -lgsl -lgslcblas -lpthread 
INCLUDES += -I. -I/usr/include/gsl

## #gcc
OTHERFLAGS = -pipe $(CPUOPTION)
ifdef DEBUG
CXXOPTFLAGS = -O
OTHERFLAGS += -g -DDEBUG 
else
CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS)
WARNING_FLAGS += $(WARN_INLINE)
ifdef RELEASE
OTHERFLAGS +=  -DNDEBUG
endif
ifndef PROF
CXXOPTFLAGS += -fomit-frame-pointer
endif
endif

CXXFLAGS = $(PROF) $(OTHERFLAGS) $(CXXOPTFLAGS) $(WARNING_FLAGS) $(INCLUDES)

SRCS = gpsshell.cc board.cc book.cc httpclient.cc ignorelist.cc
OBJS = $(patsubst %.cc,%.o,$(SRCS))
PROGRAMS = gpsshell httpclient-sample

all: $(PROGRAMS)

gpsshell: $(OBJS)
ifeq ($(USE_TOKYO_CABINET),1)
gpsshell: $(GPSSHOGI_HOME)/lib/recorddb/libgpsshogirecorddb.a $(GPSSHOGI_HOME)/lib/dbm/libgpsshogidbm.a
endif
httpclient-sample : httpclient-sample.o httpclient.o

CC = $(CXX)

gpsshell : $(FILE_OSL_ALL)

clean:
	-rm *.o $(PROGRAMS)
	-rm -rf .deps

light-clean:
	-rm -rf .deps .objs .gch 

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

=== sample/graphic/Makefile ===
GPSSHOGI_HOME = ../..
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

# type make RELEASE=yes to build optimized programs
# type make DEBUG=yes to build programs for debugging

LDFLAGS += -L$(OSL_LIB_DIR) `Magick++-config --ldflags`
LOADLIBES += /usr/local/lib/libthrift.a -lm -lboost_thread$(BOOST_POSTFIX_MT) -lboost_program_options$(BOOST_POSTFIX) -lboost_filesystem$(BOOST_POSTFIX) -lboost_regex$(BOOST_POSTFIX) `Magick++-config --libs` 
CXXOPTFLAGS += `Magick++-config --cppflags`

INCLUDES += -I. -I./gen-cpp -I/usr/local/include/thrift

ifndef RELEASE
CXXOPTFLAGS ?= -O -DDEBUG
else
CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS) -DNDEBUG
endif

ifneq ($(CXX),icc)
## gcc
ifdef RELEASE
WARNING_FLAGS += -Werror $(WARN_INLINE)
else
OTHERFLAGS = $(DEBUGFLAGS)
endif
OTHERFLAGS += -pipe $(CPUOPTION)
ifndef PROF
CXXOPTFLAGS += -fomit-frame-pointer
endif
endif

CXXFLAGS =  -DOSL_HOME=\"$(shell dirname `pwd`)\" $(PROF) $(OTHERFLAGS) $(CXXOPTFLAGS) \
	    $(GCH_INCLUDES) $(INCLUDES) $(ADDITIONALFLAGS)

PROGRAMS = graphicserver
CC = $(CXX)

THRIFT_SRCS = gen-cpp/ShogiGraphic.cpp \
	      gen-cpp/graphicserver_constants.cpp \
	      gen-cpp/graphicserver_types.cpp
THRIFT_OBJS = $(THRIFT_SRCS:.cpp=.o)
GRAPHICSERVER_SRCS = graphicserver.cc pos2img.cc
GRAPHICSERVER_OBJS = $(GRAPHICSERVER_SRCS:.cc=.o)

.PHONY: all
all: $(PROGRAMS)

$(THRIFT_SRCS): graphicserver.thrift
	/usr/local/bin/thrift --gen cpp --gen rb $<

$(GRAPHICSERVER_OBJS): $(THRIFT_OBJS)

graphicserver: $(GRAPHICSERVER_OBJS) $(THRIFT_OBJS) $(FILE_OSL_BOARD)

.PHONY: clean
clean: 
	-rm -f core $(GRAPHICSERVER_OBJS) $(PROGRAMS) gen-rb gen-cpp nohup.out *~

.PHONY: distclean
distclean: clean 
	rm -f *~

=== sample/checkeval/figs/Makefile ===
GPSSHOGI_HOME = ../../..
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

RAW_DATA = ../pdp40k-200k.txt

figs: pdp-figs tree-figs

pdp-figs: \
 escape-proof.scat escape-disproof.scat escape-unknown.scat \
 sokudumi-proof.scat sokudumi-disproof.scat \
 tsumero-proof.scat tsumero-disproof.scat tsumero-unknown.scat

tree-figs: \
 tsumero-proof-tree.scat tsumero-disproof-tree.scat \
 escape-proof-tree.scat escape-disproof-tree.scat

## eps
pdp.eps: pdp-figs
	(echo "set logscale x; set logscale y; set term postscript eps 22; set out '$@'"; \
	echo "set xlabel 'proof number'; set ylabel 'disproof number'"; \
	echo "plot 'tsumero-proof.scat' t 'tsumero (proof)', 'tsumero-disproof.scat' every 17 t 'tsumero (disproof)', 'escape-proof.scat' t 'escape (proof)', 'escape-disproof.scat' every 17 t 'escape (disproof)', x t 'x=1'") \
	| gnuplot
pdp-tree.eps: tree-figs
	(echo "set term postscript eps 22; set out '$@'"; \
	echo "set xlabel '1/sqrt(sqrt(size of proof tree))'; set ylabel 'proof (positive)/disproof (negative) number'"; \
	echo "plot 'escape-proof-tree.scat' t 'escape (proof)', 'escape-disproof-tree.scat' every 17 t 'escape(disproof)', 'tsumero-proof-tree.scat' t 'tsumero (proof)', 'tsumero-disproof-tree.scat' every 17 t 'tsumero (disproof)'") \
	| gnuplot
#'tsumero-unknown.scat', 'escape-unknown.scat'

## åǡ
# - 
escape-proof.scat: $(RAW_DATA)
	awk '$$3==0{print $$5, $$6}' < $< > $@
escape-disproof.scat: $(RAW_DATA)
	awk '$$3==1{print $$5, $$6}' < $< > $@
escape-unknown.scat: $(RAW_DATA)
	awk '$$3==2{print $$5, $$6}' < $< > $@
# - ¨
sokudumi-proof.scat: $(RAW_DATA)
	awk '$$7==0{print $$9, $$10}' < $< > $@
sokudumi-disproof.scat: $(RAW_DATA)
	awk '$$7==1{print $$9, $$10}' < $< > $@
# - ͤ
tsumero-proof.scat: $(RAW_DATA)
	awk '$$11==0{print $$13, $$14}' < $< > $@
tsumero-disproof.scat: $(RAW_DATA)
	awk '$$11==1{print $$13, $$14}' < $< > $@
tsumero-unknown.scat: $(RAW_DATA)
	awk '$$11==2{print $$13, $$14}' < $< > $@

## ڤȤδط
tsumero-proof-tree.scat: $(RAW_DATA)
	awk '$$11==0{print 1.0/sqrt(sqrt($$12)), log($$13); print 1.0/sqrt(sqrt($$12)), -log($$14)}' < $< > $@
tsumero-disproof-tree.scat: $(RAW_DATA)
	awk '$$11==1{print -1.0/sqrt(sqrt($$12)), log($$13); print -1.0/sqrt(sqrt($$12)), -log($$14)}' < $< > $@
escape-proof-tree.scat: $(RAW_DATA)
	awk '$$3==0{print 1.0/sqrt(sqrt($$4)), log($$5); print 1.0/sqrt(sqrt($$4)), -log($$6)}' < $< > $@
escape-disproof-tree.scat: $(RAW_DATA)
	awk '$$3==1{print -1.0/sqrt(sqrt($$4)), log($$5); print -1.0/sqrt(sqrt($$4)), -log($$6)}' < $< > $@


## - ͤޤʤڤ礭 $11==0 λ
#disproof-log2.hist: pdp40k-r.txt
#	awk '$$6 > 1 {print log($$6)/log(2)}' $< | histogram.pl 1 > $@
#disproof.hist: pdp40k-r.txt
#	awk '$$6 > 1 {print $$6}' $< | histogram.pl 16 > $@
#disproof.eps: disproof-log2.hist
#	echo "set term postscript eps 22; set out '$@'; set format x '2^%g'; \
#	set xlabel 'size of trees'; \
#	set ylabel 'frequencies'; \
#	plot '$<' t 'histogram of size of disproof trees' w steps " | gnuplot 
## - ͤڤ礭 $7>0 λ
#tsumero-log2.hist: pdp40k-r.txt
#	awk '$$7 > 0 {print log($$7)/log(2)}' $< | histogram.pl 1 > $@
#tsumero.hist: pdp40k-r.txt
#	awk '$$7 > 0 {print $$7}' $< | histogram.pl 16 > $@
#tsumero.eps: tsumero-log2.hist
#	echo "set term postscript eps 22; set out '$@'; set format x '2^%g'; \
#	set xlabel 'size of trees'; \
#	set ylabel 'frequencies'; \
#	plot '$<' t 'histogram of size of proof trees' w steps " | gnuplot

=== sample/checkeval/fitting/Makefile ===
# PREDICTION_SCALE
PS ?= 20
# attack or defense
AD ?= attack
# evaluation function
EVAL ?= e
THRESHOLD ?= 500

LEARN_PDP = ../pdp40k-$(PS).txt
KIF_FILE = ../../../data/kisen/01.kif

POSITIONS = ps$(PS)-$(AD)-positions.txt

LEARN_POSITIONS = $(POSITIONS:.txt=)-l.txt
LEARN_INSTANCES = ps$(PS)-$(AD)-$(EVAL)-instances-l.txt

VALIDATION_POSITIONS = $(POSITIONS:.txt=)-v.txt
VALIDATION_INSTANCES = $(LEARN_INSTANCES:-l.txt=)-v.txt

PROOF_WEIGHTS = ps$(PS)-$(AD)-$(EVAL)-proof.txt
PROOF_VALIDATE = $(PROOF_WEIGHTS:.txt=.scat)
DISPROOF_WEIGHTS =  $(subst proof,disproof,$(PROOF_WEIGHTS))
DISPROOF_VALIDATE = $(subst proof,disproof,$(PROOF_VALIDATE))

# programs
LEARN = ../learn -T $(THRESHOLD) -H $(EVAL)
VALIDATE = ../evalpositions -k $(KIF_FILE) -H $(EVAL)

positions: $(LEARN_POSITIONS) # $(VALIDATION_POSITIONS)
instances: $(LEARN_INSTANCES) $(VALIDATION_INSTANCES)
proof-weights:  $(PROOF_WEIGHTS) 
proof-validate: $(PROOF_VALIDATE)
disproof-weights:  $(DISPROOF_WEIGHTS)
disproof-validate: $(DISPROOF_VALIDATE)

$(POSITIONS): $(LEARN_PDP)
	../tools/extract.pl $(LEARN_PDP) > $@
$(LEARN_POSITIONS): $(POSITIONS) 
	../tools/shuffle.pl $(POSITIONS:.txt=) 
$(LEARN_INSTANCES): $(LEARN_POSITIONS)
	../analyzerecord -H $(EVAL) -k $(KIF_FILE) < $< > $@
$(VALIDATION_INSTANCES): $(VALIDATION_POSITIONS)
	../analyzerecord -H $(EVAL)  -k $(KIF_FILE) < $< > $@

$(PROOF_WEIGHTS): $(LEARN_POSITIONS) $(LEARN_INSTANCES)
	$(LEARN) -M p -w $@ -I $(LEARN_INSTANCES) -P $(LEARN_POSITIONS)
$(PROOF_VALIDATE): $(VALIDATION_POSITIONS) $(VALIDATION_INSTANCES)
	$(LEARN) -M p -w $(PROOF_WEIGHTS) -V -I $(VALIDATION_INSTANCES) \
	   -P $(VALIDATION_POSITIONS) > $@

$(DISPROOF_WEIGHTS): $(LEARN_POSITIONS)
	$(LEARN) -M d -w $@ -I $(LEARN_INSTANCES) -P $(LEARN_POSITIONS)
$(DISPROOF_VALIDATE): $(LEARN_POSITIONS)
	$(LEARN) -M d -w $(DISPROOF_WEIGHTS) -V -I $(VALIDATION_INSTANCES) \
	   -P $(VALIDATION_POSITIONS) > $@

clean:
	rm $(POSITIONS) $(INSTANCES)

### 
validation-$(AD)-null-null.txt:
	$(VALIDATE) -o $@ -P < $(VALIDATION_POSITIONS)
validation-$(AD)-null-piece.txt:
	$(VALIDATE) -o $@ < $(VALIDATION_POSITIONS)
validation-$(AD)-$(PS)-$(EVAL)-null.txt:
	$(VALIDATE) -o $@ -S $(PS) -P -p $(PROOF_WEIGHTS) -d $(DISPROOF_WEIGHTS) < $(VALIDATION_POSITIONS)
validation-$(AD)-$(PS)-$(EVAL)-piece.txt:
	$(VALIDATE) -o $@ -S $(PS) -p $(PROOF_WEIGHTS) -d $(DISPROOF_WEIGHTS) < $(VALIDATION_POSITIONS)

### 
# *.scat 
#  ../tools/validation_summary.pl validation-*.txt  
## 
# n2
#../../tools/scatter.sh validation-proof+null-piece+20-n2-piece.scat    proven null+piece    n2+piece 
#../../tools/scatter.sh validation-proof+null-null+20-n2-null.scat      proven null+null     n2+null 
#../../tools/scatter.sh validation-disproof+null-piece+20-n2-piece.scat disproven null+piece n2+piece 
#../../tools/scatter.sh validation-disproof+null-null+20-n2-null.scat   disproven null+null  n2+null 
## n
#../../tools/scatter.sh validation-proof+null-piece+20-n-piece.scat    proven null+piece    n+piece 
#../../tools/scatter.sh validation-proof+null-null+20-n-null.scat      proven null+null     n+null 
#../../tools/scatter.sh validation-disproof+null-piece+20-n-piece.scat disproven null+piece n+piece 
#../../tools/scatter.sh validation-disproof+null-null+20-n-null.scat   disproven null+null  n+null 
## e
#../../tools/scatter.sh validation-proof+null-piece+20-e-piece.scat    proven null+piece    e+piece 
#../../tools/scatter.sh validation-proof+null-null+20-e-null.scat      proven null+null     e+null 
#../../tools/scatter.sh validation-disproof+null-piece+20-e-piece.scat disproven null+piece e+piece 
#../../tools/scatter.sh validation-disproof+null-null+20-e-null.scat   disproven null+null  e+null 


###  histogram
#ps10-attack-positions-l.hist
ps$(PS)-%-l-p.hist: ps$(PS)-%-l.txt
	awk '$$3 < $(PS) {print $$3} $$3 >= $(PS) {print $(PS)}' $< | histogram.pl 2 > $@
ps$(PS)-%-l-d.hist: ps$(PS)-%-l.txt
	awk '$$4 < $(PS) {print $$4} $$4 >= $(PS) {print $(PS)}' $< | histogram.pl 2 > $@

# ../tools/pd-hist.sh

=== sample/eval/bin/Makefile ===
GPSSHOGI_HOME = ../../..
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

OTHERFLAGS = -pipe $(CPUOPTION)
ifdef DEBUG
CXXOPTFLAGS ?= -O0
OTHERFLAGS += -g -DDEBUG
else
CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS)
WARNING_FLAGS += $(WARN_INLINE)
ifdef RELEASE
OTHERFLAGS +=  -DNDEBUG
endif
endif

ifdef PROFILE
PROF = $(PROFILE_FLAGS)
LDFLAGS += $(PROF)
endif

INCLUDES += -I../lib
CXXFLAGS = $(PROF) $(OTHERFLAGS) $(CXXOPTFLAGS) $(WARNING_FLAGS) $(INCLUDES)
LOADLIBES += -lboost_program_options$(BOOST_POSTFIX) -lboost_thread$(BOOST_POSTFIX_MT) -ltbb -lz

SRCS = pv.cc show-eval.cc cross-validate.cc \
  l1ball.cc move-rating.cc select-record.cc find-pv.cc \
  one-sided-features.cc find-overfit.cc compare-pv.cc
PROGRAMS = $(SRCS:.cc=)

LIB_EVAL = ../lib/libeval.a

all: 
	$(MAKE) update-lib 
	$(MAKE) $(PROGRAMS)
$(PROGRAMS): $(LIB_EVAL) $(FILE_OSL_ALL)

CC = $(CXX)

update-lib:
	cd ../lib; $(MAKE) RELEASE=$(RELEASE)

clean: 
	-rm -f core *.o $(PROGRAMS) nohup.out *~
	-rm -rf .deps
	$(MAKE) -C ../lib clean
distclean: clean 
	rm -f *~

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

.PHONY: all update-lib clean distclean

=== sample/eval/lib/Makefile ===
GPSSHOGI_HOME = ../../..
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

OTHERFLAGS = -g -pipe $(CPUOPTION)
ifdef DEBUG
CXXOPTFLAGS = -O0
OTHERFLAGS += -DDEBUG
else
CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS)
WARNING_FLAGS += $(WARN_INLINE)
ifdef RELEASE
OTHERFLAGS +=  -DNDEBUG
endif
ifdef PROFILE
OTHERFLAGS +=  -DNDEBUG
endif
endif

WARNING_FLAGS += -Wno-sign-compare

CXXFLAGS = $(PROF) $(OTHERFLAGS) $(CXXOPTFLAGS) $(WARNING_FLAGS) $(INCLUDES)
INCLUDES += -I.

all: libeval.a

CC = $(CXX)

OBJS = quiesce.o analyzer.o pvFile.o pvGenerator.o \
	l1Ball.o rotateRecord.o pvVector.o \
	eval/eval.o eval/evalFactory.o eval/kingEval.o \
	eval/ptypeAttacked.o eval/piecePair.o \
	eval/progress.o eval/pin.o eval/pieceStand.o \
	eval/mobility.o eval/minorPiece.o eval/majorPiece.o \
	eval/progressFeature.o eval/openMidEnding.o \
	eval/ptypeEval.o eval/piecePairKing.o
SRCS = $(OBJS:.o=.cc)

libeval.a : $(OBJS)
	-rm $@
	$(ARC) $@ $(OBJS)
	-$(RANLIB) $@

clean: 
	-rm -f core $(OBJS) *.o $(PROGRAMS) nohup.out *~
	-rm -rf .deps
distclean: clean 
	rm -f *~

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

=== sample/eval/test/Makefile ===
GPSSHOGI_HOME = ../../..
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

LOADLIBES += -lboost_thread$(BOOST_POSTFIX_MT) $(LDLIBS) -lz
INCLUDES += -I../lib -I$(OSL_HOME)/lib/third_party/$(GTEST)/include
GTEST_LIBES += $(OSL_HOME)/lib/third_party/$(GTEST)/lib/.libs/libgtest.a

WARNING_FLAGS += -Wno-sign-compare

CXXOPTFLAGS ?= -O -DDEBUG
ifneq ($(CXX),icc)
OTHERFLAGS = -pipe $(DEBUGFLAGS) $(CPUOPTION)
endif
CXXFLAGS = $(CXXOPTFLAGS) $(OTHERFLAGS) \
	$(WARNING_FLAGS) $(GCH_INCLUDES) $(INCLUDES)

PROGRAMS = testAll
LIB_EVAL = ../lib/libeval.a

all : 
	$(MAKE) update-lib
	$(MAKE) test-target
test-target: $(PROGRAMS)
update-lib:
	cd ../lib; $(MAKE)

TEST_OBJS = eval.t.o minorPiece.t.o majorPiece.t.o \
	quiesce.t.o pvFile.t.o l1Ball.t.o
OBJS = testAll.o $(TEST_OBJS)
SRCS = $(patsubst %.o,%.cc,$(OBJS))

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

testAll: $(OBJS) $(LIB_EVAL) $(FILE_OSL_ALL)
	mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LOADLIBES) $(GTEST_LIBES)

light-clean:
	-rm -rf .deps 
clean: light-clean
	-rm -f core *.o $(OBJS) $(PROGRAMS) nohup.out checkmate.log
distclean: clean 
	rm -f *~

=== debian/changelog ===
gpsshogi (0.3.0-1) unstable; urgency=low

  * New upstream release (r2361).
  * Added debian/source/format file.
  * Added debian/README.source file.
  * Added debian/gpsshogi.menu to add gpsshogi-view into Menu.
  * Now man pages go to section 6 (for games).
  * Fixed a FTBFS error. (Closes: #582984)
  * Converted the patch system to quilt.
  * Added debian/patches
    - 20100525-viewer-version_r2364-2365.patch.
    - 20100528-makefile_conf_remove_malloc.patch.
  * Added a man page gpsshogi-viewer.1 for gpsshogi-viewer
    since running the command on the fly is hard due to an X11
    configuration.

 -- Daigo Moriwaki <daigo@debian.org>  Tue, 25 May 2010 21:49:28 +0900

gpsshogi (0.2.0-3) unstable; urgency=low

  * debian/control, debian:rules: Added sample/gpsshell.
  * debian/control: Bumped up Standards-Version to 3.8.4.

 -- Daigo Moriwaki <daigo@debian.org>  Sun, 07 Feb 2010 19:32:41 +0900

gpsshogi (0.2.0-2) unstable; urgency=low

  * debian/rules: Enable to use CDBS's simple patch system.
  * debian/patches/20100206-qt-common.pro.patch: Added a patch to
    ./qt-common.pro
  * Added gpsshogi-viewer

 -- Daigo Moriwaki <daigo@debian.org>  Sat, 06 Feb 2010 16:05:16 +0900

gpsshogi (0.2.0-1) unstable; urgency=low

  * Initial release. (Closes: #567621)

 -- Daigo Moriwaki <daigo@debian.org>  Sat, 30 Jan 2010 18:48:02 +0900

=== debian/control ===
Source: gpsshogi
Section: games
Priority: optional
Maintainer: Daigo Moriwaki <daigo@debian.org>
Build-Depends: debhelper (>= 7), cdbs, quilt, libosl-dev (>= 0.3.0), libboost1.42-all-dev, libgoogle-perftools-dev, chrpath, help2man, libqt4-dev, qt4-dev-tools, libpoco-dev, libreadline5-dev, libgsl0-dev
Standards-Version: 3.8.4
Homepage: http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/pukiwiki.php
Vcs-Browser: http://git.debian.org/?p=collab-maint/gpsshogi.git;a=summary
Vcs-Git: git://git.debian.org/git/collab-maint/gpsshogi.git

Package: gpsshogi
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, gpsshogi-data (= ${source:Version})
Description: Shogi playing program based on OpenShogiLib
 GPSShogi is a Shogi playing program based on OpenShogiLib and won the 19th
 World Computer Shogi Championship. This package contains several binaries to
 play with computer Shogi.
  - gpsshogi: support the CSA protocol
  - gpsusi: support the USI protocol
  - gpsshogi-viewer: GUI application to investigate positions
  - gpsshell: shell-like client to investigate positions

Package: gpsshogi-data
Architecture: all
Recommends: gpsshogi
Depends: ${misc:Depends}
Description: data files for gpsshogi
 GPSShogi is a Shogi playing program based on OpenShogiLib and won the 19th
 World Computer Shogi Championship. This package contains several binaries to
 play with computer Shogi.
  - gpsshogi: support the CSA protocol
  - gpsusi: support the USI protocol
  - gpsshogi-viewer: GUI application to investigate positions
  - gpsshell: shell-like client to investigate positions
 .
 This package contains data files defining parameters of evaluation functions,
 an opening book for gpsshogi

Package: gpsshogi-dbg
Priority: extra
Section: debug
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, gpsshogi (= ${binary:Version})
Description: Shogi playing program based on OpenShogiLib
 GPSShogi is a Shogi playing program based on OpenShogiLib and won the 19th
 World Computer Shogi Championship
 .
 This package is provided primarily to provide a backtrace with names in a
 debugger and makes it easier to interpret core dumps. Most users will not
 need this package.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

DEB_MAKE_CLEAN_TARGET   = clean
DEB_MAKE_BUILD_TARGET   = all
DEB_MAKE_INSTALL_TARGET = 
DEB_MAKE_CHECK_TARGET   =

so_ver=1

DEB_DBG_PACKAGE_gpsshogi = gpsshogi-dbg
DEB_INSTALL_DIRS_gpsshogi += usr/games
DEB_INSTALL_MANPAGES_gpsshogi += debian/gpsusi.1
DEB_INSTALL_MANPAGES_gpsshogi += debian/gpsshogi.1
DEB_INSTALL_MANPAGES_gpsshogi += debian/gpsshell.1
DEB_INSTALL_MANPAGES_gpsshogi += debian/gpsshogi-viewer.1
DEB_INSTALL_DIRS_gpsshogi_data += usr/share/gpsshogi-data/data

pre-build::
	cp $(CURDIR)/debian/qt-common-local.pro.$(DEB_HOST_ARCH_CPU) $(CURDIR)/qt-common-local.pro

build/gpsshogi::
	# gpsusi, gpsshogi
	$(MAKE) -C bin OSL_HOME=/usr/share/libosl-dev OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" FILE_TCMALLOC='' FILE_OSL_ALL='' LDLIBS='-losl -lboost_system-mt -lboost_filesystem-mt -ltcmalloc_minimal' RELEASE=t gpsshogi gpsusi
	help2man --section 6 -n "GPSShogi for XShogi and the CSA protocol" --no-info \
	  $(CURDIR)/bin/gpsshogi > $(CURDIR)/debian/gpsshogi.1
	help2man --section 6 -n "GPSShogi for the USI protocol" --no-info \
	  $(CURDIR)/bin/gpsusi > $(CURDIR)/debian/gpsusi.1
	# gpsshell
	$(MAKE) -C sample/gpsshell OSL_HOME=/usr/share/libosl-dev OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" FILE_TCMALLOC='' FILE_OSL_ALL='' LDLIBS='-losl -lboost_system-mt -lboost_filesystem-mt -ltcmalloc_minimal' RELEASE=t gpsshell
	help2man --section 6 -n "GPSShogi shell like client" --version-string "gpsshell" --no-info \
	  $(CURDIR)/sample/gpsshell/gpsshell > $(CURDIR)/debian/gpsshell.1
	# viewer
	for dir in lib/gui sample/viewer ; do \
	  (cd $(CURDIR)/$$dir && \
	   qmake OSL_HOME_QT="" TCMALLOC="" OSL_HOME=/usr/share/libosl-dev && \
	   $(MAKE) OSL_HOME_QT="" TCMALLOC="" OSL_HOME=/usr/share/libosl-dev) ; \
	done

binary-install/gpsshogi::
	dh_install -p$(cdbs_curpkg) --sourcedir=bin gpsshogi gpsusi usr/games
	dh_install -p$(cdbs_curpkg) --sourcedir=sample/gpsshell gpsshell usr/games
	mv $(CURDIR)/sample/viewer/viewer $(CURDIR)/sample/viewer/gpsshogi-viewer 
	dh_install -p$(cdbs_curpkg) --sourcedir=sample/viewer gpsshogi-viewer usr/games
	for file in gpsusi gpsshogi gpsshell gpsshogi-viewer ; do \
	  chrpath --delete $(CURDIR)/debian/$(cdbs_curpkg)/usr/games/$$file ; \
	done

binary-install/gpsshogi-data::
	dh_install -p$(cdbs_curpkg) --sourcedir=data joseki.dat usr/share/$(cdbs_curpkg)/data
	dh_install -p$(cdbs_curpkg) --sourcedir=data -X.pl -X.svn rating usr/share/$(cdbs_curpkg)/data
	for file in \
	  sibling-attack.pair eval.txt eval-info.txt \
	  progress.txt progress-info.txt \
	  ; \
	do \
	  dh_install -p$(cdbs_curpkg) --sourcedir=data $$file usr/share/$(cdbs_curpkg)/data ; \
	done

clean::
	for dir in lib/gui sample/viewer ; do \
	  [ ! -f $$dir/Makefile ] || $(MAKE) -C $$dir OSL_HOME=/usr/share/libosl-dev distclean ; \
	done
	for dir in lib bin sample/gpsshell ; do \
	  $(MAKE) -C $$dir OSL_HOME=/usr/share/libosl-dev clean ; \
	done
	-rm -f $(CURDIR)/sample/viewer/gpsshogi-viewer
	-rm -f $(CURDIR)/qt-common-local.pro
	for file in gpsusi gpsshogi gpsshell ; do \
	  rm -rf $(CURDIR)/debian/$file.1 ; \
	done

## gpsshogi 0.4.0

=== bin/Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 LDFLAGS += $(PROF)
 endif
 
-LOADLIBES += -lboost_thread$(BOOST_POSTFIX_MT) -lboost_program_options$(BOOST_POSTFIX) -lpthread
+LOADLIBES += -lboost_thread$(BOOST_POSTFIX_MT) -lboost_program_options$(BOOST_POSTFIX) -lboost_system$(BOOST_POSTFIX) -lpthread
 
 ## #gcc
 OTHERFLAGS = -pipe $(CPUOPTION)

=== sample/gpsshell/Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 
 CXXFLAGS = $(PROF) $(OTHERFLAGS) $(CXXOPTFLAGS) $(WARNING_FLAGS) $(INCLUDES)
 
-SRCS = gpsshell.cc board.cc book.cc httpclient.cc ignorelist.cc
+SRCS = gpsshell.cc board.cc book.cc commands.cc httpclient.cc ignorelist.cc
 OBJS = $(patsubst %.cc,%.o,$(SRCS))
 PROGRAMS = gpsshell httpclient-sample

=== sample/eval/bin/Makefile ===
--- 
+++ 
@@ -21,11 +21,12 @@
 
 INCLUDES += -I../lib
 CXXFLAGS = $(PROF) $(OTHERFLAGS) $(CXXOPTFLAGS) $(WARNING_FLAGS) $(INCLUDES)
-LOADLIBES += -lboost_program_options$(BOOST_POSTFIX) -lboost_thread$(BOOST_POSTFIX_MT) -ltbb -lz
+LOADLIBES += -lboost_program_options$(BOOST_POSTFIX) -lboost_thread$(BOOST_POSTFIX_MT) -lz
 
-SRCS = pv.cc show-eval.cc cross-validate.cc \
+SRCS = pv.cc pvall.cc show-eval.cc cross-validate.cc \
   l1ball.cc move-rating.cc select-record.cc find-pv.cc \
-  one-sided-features.cc find-overfit.cc compare-pv.cc
+  one-sided-features.cc find-overfit.cc compare-pv.cc \
+  bonanza-learn.cc progressevalstat.cc
 PROGRAMS = $(SRCS:.cc=)
 
 LIB_EVAL = ../lib/libeval.a

=== sample/move-probability/test/Makefile ===
GPSSHOGI_HOME = ../../..
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

LOADLIBES += -lboost_thread$(BOOST_POSTFIX_MT) $(LDLIBS) -lz
INCLUDES += -I../lib -I$(OSL_HOME)/lib/third_party/$(GTEST)/include
GTEST_LIBES += $(OSL_HOME)/lib/third_party/$(GTEST)/lib/.libs/libgtest.a

WARNING_FLAGS += -Wno-sign-compare

CXXOPTFLAGS ?= -O -DDEBUG
ifneq ($(CXX),icc)
OTHERFLAGS = -pipe $(DEBUGFLAGS) $(CPUOPTION)
endif
CXXFLAGS = $(CXXOPTFLAGS) $(OTHERFLAGS) \
	$(WARNING_FLAGS) $(GCH_INCLUDES) $(INCLUDES)

PROGRAMS = testAll
LIB_MOVEPROB = ../lib/libmoveprob.a

all : 
	$(MAKE) update-lib
	$(MAKE) test-target
test-target: $(PROGRAMS)
update-lib:
	cd ../lib; $(MAKE)

TEST_OBJS = feature.t.o stateInfo.t.o featureSet.t.o moveInfo.t.o
OBJS = testAll.o $(TEST_OBJS)
SRCS = $(patsubst %.o,%.cc,$(OBJS))

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

testAll: $(OBJS) $(LIB_MOVEPROB) $(FILE_OSL_ALL)
	mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LOADLIBES) $(GTEST_LIBES)

light-clean:
	-rm -rf .deps 
clean: light-clean
	-rm -f core *.o $(OBJS) $(PROGRAMS) nohup.out checkmate.log
distclean: clean 
	rm -f *~

=== debian/changelog ===
gpsshogi (0.4.0-1) unstable; urgency=low

  * New upstream release (r2566).
  * debian/control
    - Bumped up Standards-Version to 3.9.2.
    - Build with Boost 1.46.
    - Build with libreadline6-dev
  * updated debian/patches/20100206-qt-common.pro.patch.
  * removed debian/patches/20100525-viewer-version_r2364-2365.patch, which was
    applied by the stream.

 -- Daigo Moriwaki <daigo@debian.org>  Sat, 11 Jun 2011 18:29:02 +0900

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: games
 Priority: optional
 Maintainer: Daigo Moriwaki <daigo@debian.org>
-Build-Depends: debhelper (>= 7), cdbs, quilt, libosl-dev (>= 0.3.0), libboost1.42-all-dev, libgoogle-perftools-dev, chrpath, help2man, libqt4-dev, qt4-dev-tools, libpoco-dev, libreadline5-dev, libgsl0-dev
-Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 7), cdbs, quilt, libosl-dev (>= 0.4.0), libboost1.46-all-dev, libgoogle-perftools-dev, chrpath, help2man, libqt4-dev, qt4-dev-tools, libpoco-dev, libreadline6-dev, libgsl0-dev
+Standards-Version: 3.9.2
 Homepage: http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/pukiwiki.php
 Vcs-Browser: http://git.debian.org/?p=collab-maint/gpsshogi.git;a=summary
 Vcs-Git: git://git.debian.org/git/collab-maint/gpsshogi.git

=== debian/rules ===
--- 
+++ 
@@ -23,13 +23,13 @@
 
 build/gpsshogi::
 	# gpsusi, gpsshogi
-	$(MAKE) -C bin OSL_HOME=/usr/share/libosl-dev OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" FILE_TCMALLOC='' FILE_OSL_ALL='' LDLIBS='-losl -lboost_system-mt -lboost_filesystem-mt -ltcmalloc_minimal' RELEASE=t gpsshogi gpsusi
+	$(MAKE) -C bin OSL_HOME=/usr/share/libosl-dev OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" FILE_TCMALLOC='' FILE_OSL_ALL='' LDLIBS='-losl -lboost_system -lboost_filesystem -lboost_iostreams -lboost_serialization -ltcmalloc_minimal' RELEASE=t gpsshogi gpsusi
 	help2man --section 6 -n "GPSShogi for XShogi and the CSA protocol" --no-info \
 	  $(CURDIR)/bin/gpsshogi > $(CURDIR)/debian/gpsshogi.1
 	help2man --section 6 -n "GPSShogi for the USI protocol" --no-info \
 	  $(CURDIR)/bin/gpsusi > $(CURDIR)/debian/gpsusi.1
 	# gpsshell
-	$(MAKE) -C sample/gpsshell OSL_HOME=/usr/share/libosl-dev OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" FILE_TCMALLOC='' FILE_OSL_ALL='' LDLIBS='-losl -lboost_system-mt -lboost_filesystem-mt -ltcmalloc_minimal' RELEASE=t gpsshell
+	$(MAKE) -C sample/gpsshell OSL_HOME=/usr/share/libosl-dev OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" FILE_TCMALLOC='' FILE_OSL_ALL='' LDLIBS='-losl -lboost_system -lboost_filesystem -lboost_iostreams -lboost_serialization -ltcmalloc_minimal' RELEASE=t gpsshell
 	help2man --section 6 -n "GPSShogi shell like client" --version-string "gpsshell" --no-info \
 	  $(CURDIR)/sample/gpsshell/gpsshell > $(CURDIR)/debian/gpsshell.1
 	# viewer
@@ -52,9 +52,9 @@
 	dh_install -p$(cdbs_curpkg) --sourcedir=data joseki.dat usr/share/$(cdbs_curpkg)/data
 	dh_install -p$(cdbs_curpkg) --sourcedir=data -X.pl -X.svn rating usr/share/$(cdbs_curpkg)/data
 	for file in \
-	  sibling-attack.pair eval.txt eval-info.txt \
-	  progress.txt progress-info.txt \
-	  ; \
+	  sibling-attack.pair eval.bin eval-info.txt \
+	  move-order.bin move-order-info.txt move-tactical.txt \
+	  progress.txt progress-info.txt ; \
 	do \
 	  dh_install -p$(cdbs_curpkg) --sourcedir=data $$file usr/share/$(cdbs_curpkg)/data ; \
 	done
@@ -69,6 +69,6 @@
 	-rm -f $(CURDIR)/sample/viewer/gpsshogi-viewer
 	-rm -f $(CURDIR)/qt-common-local.pro
 	for file in gpsusi gpsshogi gpsshell ; do \
-	  rm -rf $(CURDIR)/debian/$file.1 ; \
+	  rm -rf $(CURDIR)/debian/$$file.1 ; \
 	done

## gpsshogi 0.4.2

=== bin/CMakeLists.txt ===
project (gpsshogi CXX)
cmake_minimum_required (VERSION 2.8)
set (CMAKE_VERBOSE_MAKEFILE on)

ENABLE_TESTING()

if (UNIX)
  set (CMAKE_CXX_FLAGS "-Wall")
  set (CMAKE_CXX_FLAGS_DEBUG "-O0 -g -DDEBUG")
  set (CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG")
  add_definitions(-march=native -DBOOST_FILESYSTEM_VERSION=2) 
endif()

if(MINGW)
  set (CMAKE_CXX_FLAGS "-Wall -mthreads")
  set (CMAKE_CXX_FLAGS_DEBUG "-O0 -g -DDEBUG")
  set (CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG -march=pentium4 -funroll-loops -funswitch-loops -fpeel-loops --param large-function-growth=48000 --param inline-unit-growth=8000 --param max-inline-insns-single=8000 -fomit-frame-pointer")
  add_definitions(-DOSL_SMP=1 -DOSL_DFPN_SMP_SEARCH -DMORE_CHECKMATE_IF_CAPTURE_MAJOR -DBOOST_FILESYSTEM_VERSION=2 -DBOOST_THREAD_USE_LIB=1 -DUSE_BOOST_POOL_ALLOCATOR=1 -D_WIN32_WINNT=0x0500)
  set (BOOST_ROOT "$ENV{HOME}/local/src/boost_1_46_1/")
endif(MINGW)

add_definitions(-DOSL_HOME="${CMAKE_CURRENT_SOURCE_DIR}" -DUSE_TCMALLOC=0 -D_REENTRANT)

include_directories ("${PROJECT_SOURCE_DIR}")
include_directories ("${PROJECT_SOURCE_DIR}/../include")
include_directories ("${PROJECT_SOURCE_DIR}/../../osl/include")

## Pthreads
#find_package (Threads)
#if (Threads_FOUND)
#  message (STATUS "Threads: ${CMAKE_THREAD_LIBS_INIT}")
#else()
#  message (FATAL_ERROR "Threads not found")
#endif()

## bzip2
find_library(Bz2_LIBRARY bz2 PATH "/usr/i686-w64-mingw32/lib"
             NO_DEFAULT_PATH)

## psapi
find_library(Psapi_LIBRARY psapi PATH "/usr/i686-w64-mingw32/lib"
             NO_DEFAULT_PATH)

## Boost thing
#set (BOOST_ROOT "$ENV{HOME}/local/boost_1_36_0_binaries/")
set (Boost_USE_STATIC_LIBS ON)
set (Boost_USE_MULTITHREADED ON)
find_package (Boost 1.46.1 COMPONENTS program_options filesystem serialization iostreams thread_win32 system)
if (Boost_FOUND)
  include_directories (${Boost_INCLUDE_DIRS})
  message (STATUS ${Boost_INCLUDE_DIRS})
else()
  message (FATAL_ERROR "Boost installation not found")
endif()

## gpsshogi
set(GPSSHOGI_HEADERS  options.h)
set(GPSSHOGI_SRCS     gpsshogi.cc)
set(GPSSHIGI_ALL_SRCS ${GPSSHOGI_HEADERS} ${GPSSHOGI_SRCS})
add_executable(gpsshogi ${GPSSHIGI_ALL_SRCS})
target_link_libraries (gpsshogi ${PROJECT_SOURCE_DIR}/../../osl/mingw-release/libosl.a)
target_link_libraries (gpsshogi ${Boost_PROGRAM_OPTIONS_LIBRARY})
target_link_libraries (gpsshogi ${Boost_FILESYSTEM_LIBRARY})
target_link_libraries (gpsshogi ${Boost_SERIALIZATION_LIBRARY})
target_link_libraries (gpsshogi ${Boost_IOSTREAMS_LIBRARY})
target_link_libraries (gpsshogi ${Boost_SYSTEM_LIBRARY})
target_link_libraries (gpsshogi ${Bz2_LIBRARY})
target_link_libraries (gpsshogi ${Psapi_LIBRARY})
target_link_libraries (gpsshogi ${Boost_THREAD_WIN32_LIBRARY})

## gpsusi
set(GPSUSI_HEADERS  options.h)
set(GPSUSI_SRCS     gpsusi.cc)
set(GPSUSI_ALL_SRCS ${GPSUSI_HEADERS} ${GPSUSI_SRCS})
add_executable(gpsusi ${GPSUSI_ALL_SRCS})
target_link_libraries (gpsusi ${PROJECT_SOURCE_DIR}/../../osl/mingw-release/libosl.a)
target_link_libraries (gpsusi ${Boost_PROGRAM_OPTIONS_LIBRARY})
target_link_libraries (gpsusi ${Boost_FILESYSTEM_LIBRARY})
target_link_libraries (gpsusi ${Boost_SERIALIZATION_LIBRARY})
target_link_libraries (gpsusi ${Boost_IOSTREAMS_LIBRARY})
target_link_libraries (gpsusi ${Boost_SYSTEM_LIBRARY})
target_link_libraries (gpsusi ${Bz2_LIBRARY})
target_link_libraries (gpsusi ${Psapi_LIBRARY})
target_link_libraries (gpsusi ${Boost_THREAD_WIN32_LIBRARY})

## installer
set (CPACK_PACKAGE_VENDOR "TeamGPS")
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "GPSShogi by TeamGPS")
set (CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/../sample/binary-dist/gpsshogi_setup/README.ja.txt")
set (CPACK_PACKAGE_VERSION_MAJOR "20110731")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../sample/binary-dist/GPL-2")
#set (CPACK_PACKAGE_EXECUTABLES gpsshogi;gpsshogi) # do not create start menu
set (CPACK_PACKAGE_INSTALL_DIRECTORY "gpsshogi")

# Specific to NSIS (Windows)
#set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY HKCU "/Environment/OSL_HOME" ${CPACK_NSIS_INSTALL_ROOT})
set (CPACK_NSIS_PACKAGE_NAME "GPSShogi")
set (CPACK_NSIS_DISPLAY_NAME "GPSShogi")
set (CPACK_NSIS_URL_INFO_ABOUT "http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/")
set (CPACK_NSIS_HELP_LINK "http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/")
## registry key for OSL_HOME environment variable
set (CPACK_NSIS_EXTRA_INSTALL_COMMANDS   "WriteRegStr HKCU \\\"Environment\\\" \\\"OSL_HOME\\\" \\\"$INSTDIR\\\"")
set (CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "DeleteRegValue HKCU \\\"Environment\\\" \\\"OSL_HOME\\\"")

## Binary
install (TARGETS gpsshogi gpsusi
  RUNTIME DESTINATION smp
  LIBRARY DESTINATION smp
  ARCHIVE DESTINATION smp
)
## Data files
file (GLOB datafiles "${CMAKE_CURRENT_SOURCE_DIR}/../data/*.dat" "${CMAKE_CURRENT_SOURCE_DIR}/../data/*.bin" "${CMAKE_CURRENT_SOURCE_DIR}/../data/*.txt" "${CMAKE_CURRENT_SOURCE_DIR}/../data/*.pair")
file (GLOB dataratingfiles "${CMAKE_CURRENT_SOURCE_DIR}/../data/rating/*.txt")
install (FILES ${datafiles}       DESTINATION "data")
install (FILES ${dataratingfiles} DESTINATION "data/rating")
## README
file (GLOB readmefiles "${CMAKE_CURRENT_SOURCE_DIR}/../sample/binary-dist/gpsshogi_setup/README*.txt")
install (FILES ${readmefiles} DESTINATION "./")
## licenses for data
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../AUTHORS" "${CMAKE_CURRENT_SOURCE_DIR}/../COPYING" "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE" DESTINATION "data")
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../sample/binary-dist/GPL-2" DESTINATION "data")
## licenses for binaries
### OSL
set (OSL_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../osl")
install (FILES "${OSL_SOURCE_DIR}/AUTHORS" DESTINATION "smp" RENAME "AUTHORS.osl")
install (FILES "${OSL_SOURCE_DIR}/LICENSE" DESTINATION "smp" RENAME "LICENSE.osl")
### GPS
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../AUTHORS" DESTINATION "smp" RENAME "AUTHORS")
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../COPYING" DESTINATION "smp" RENAME "COPYING")
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE" DESTINATION "smp" RENAME "LICENSE")
### GPL
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../sample/binary-dist/GPL-2" DESTINATION "smp")
### Boost
install (FILES "${BOOST_ROOT}/LICENSE_1_0.txt" DESTINATION "smp" RENAME "copyright.boost") 
### bzip2
install (FILES "$ENV{HOME}/local/src/bzip2-1.0.6/LICENSE" DESTINATION "smp" RENAME "copyright.bzip2") 
### Mingw
install (FILES "/usr/share/doc/mingw-w64/copyright" DESTINATION "smp" RENAME "copyright.mingw")


set (CPACK_GENERATOR "NSIS")
include (CPack)

=== bin/Makefile ===
--- 
+++ 
@@ -46,18 +46,18 @@
 OSL_HOME_FLAGS = -DOSL_HOME=\"$(shell dirname `dirname \`pwd\``)/osl\"
 
 gpsone: gpsone.cc gpsone.gcda gpsshogi.cc gpsoneprof
-	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_USE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES)
+	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_USE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES) -lbz2
 gpsoneprof: gpsone.cc gpsshogi.cc
 	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_GENERATE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES)
 gpsone-static: gpsone.cc gpsshogi.cc
-	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC)  $(LOADLIBES)
+	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC)  $(LOADLIBES) -lbz2
 
 gpsusione: gpsusione.cc gpsusione.gcda gpsusi.cc gpsusioneprof
-	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_USE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES)
+	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_USE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES) -lbz2
 gpsusioneprof: gpsusione.cc gpsusi.cc
 	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_GENERATE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES)
 gpsusione-static: gpsusione.cc gpsusi.cc
-	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC)  $(LOADLIBES)
+	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC)  $(LOADLIBES) -lbz2
 
 run-profile: gpsoneprof
 	./gpsoneprof -e test --benchmark-more=16 -B45

=== sample/eval/bin/Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 LOADLIBES += -lboost_program_options$(BOOST_POSTFIX) -lboost_thread$(BOOST_POSTFIX_MT) -lz
 
 SRCS = pv.cc pvall.cc show-eval.cc cross-validate.cc \
-  l1ball.cc move-rating.cc select-record.cc find-pv.cc \
+  learn.cc move-rating.cc select-record.cc find-pv.cc \
   one-sided-features.cc find-overfit.cc compare-pv.cc \
   bonanza-learn.cc progressevalstat.cc
 PROGRAMS = $(SRCS:.cc=)

=== debian/changelog ===
gpsshogi (0.4.2-1) unstable; urgency=low

  * New upstream release (r2602).
  * Added patches:
    - debian/patches/20111010-r2603_viewer_pvModel.cc.patch
    - debian/patches/20111010-r2604_gpsshell_makefile.patch

 -- Daigo Moriwaki <daigo@debian.org>  Mon, 10 Oct 2011 16:06:43 +0900

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: games
 Priority: optional
 Maintainer: Daigo Moriwaki <daigo@debian.org>
-Build-Depends: debhelper (>= 7), cdbs, quilt, libosl-dev (>= 0.4.0), libboost1.46-all-dev, libgoogle-perftools-dev, chrpath, help2man, libqt4-dev, qt4-dev-tools, libpoco-dev, libreadline6-dev, libgsl0-dev
+Build-Depends: debhelper (>= 7), cdbs, quilt, libosl-dev (>= 0.4.2), libboost1.46-all-dev, libgoogle-perftools-dev, chrpath, help2man, libqt4-dev, qt4-dev-tools, libpoco-dev, libreadline6-dev, libgsl0-dev
 Standards-Version: 3.9.2
 Homepage: http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/pukiwiki.php
 Vcs-Browser: http://git.debian.org/?p=collab-maint/gpsshogi.git;a=summary
@@ -10,7 +10,7 @@
 
 Package: gpsshogi
 Architecture: i386 amd64
-Depends: ${shlibs:Depends}, ${misc:Depends}, gpsshogi-data (= ${source:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libosl1 (>= 0.4.2), gpsshogi-data (= ${source:Version})
 Description: Shogi playing program based on OpenShogiLib
  GPSShogi is a Shogi playing program based on OpenShogiLib and won the 19th
  World Computer Shogi Championship. This package contains several binaries to

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,11 @@
 #!/usr/bin/make -f
+
+SOURCE = $(shell dpkg-parsechangelog | grep "^Source" | sed "s/Source: //")
+VERSION = $(shell dpkg-parsechangelog | grep "^Version" | sed "s/Version: //")
+ORIG_VERSION = $(shell echo $(VERSION) | sed "s/-.*//")
+PRISTINE_VERSION = $(shell echo $(ORIG_VERSION) | sed "s/\+dfsg//")
+UPSTREAM_VERSION = $(shell echo $(PRISTINE_VERSION) | sed "s/^0\.0\.//")
+SRCDIR_NAME = $(SOURCE)-$(ORIG_VERSION).orig
 
 include /usr/share/cdbs/1/rules/debhelper.mk
 include /usr/share/cdbs/1/rules/patchsys-quilt.mk
@@ -23,13 +30,13 @@
 
 build/gpsshogi::
 	# gpsusi, gpsshogi
-	$(MAKE) -C bin OSL_HOME=/usr/share/libosl-dev OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" FILE_TCMALLOC='' FILE_OSL_ALL='' LDLIBS='-losl -lboost_system -lboost_filesystem -lboost_iostreams -lboost_serialization -ltcmalloc_minimal' RELEASE=t gpsshogi gpsusi
+	$(MAKE) -C bin OSL_HOME=/usr/share/libosl-dev OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" FILE_TCMALLOC='' FILE_OSL_ALL='' LDFLAGS='-Wl,--as-needed' LDLIBS='-losl -lboost_filesystem-mt -lboost_serialization-mt -lboost_iostreams-mt -lboost_system-mt -ltcmalloc_minimal' RELEASE=t gpsshogi gpsusi
 	help2man --section 6 -n "GPSShogi for XShogi and the CSA protocol" --no-info \
 	  $(CURDIR)/bin/gpsshogi > $(CURDIR)/debian/gpsshogi.1
 	help2man --section 6 -n "GPSShogi for the USI protocol" --no-info \
 	  $(CURDIR)/bin/gpsusi > $(CURDIR)/debian/gpsusi.1
 	# gpsshell
-	$(MAKE) -C sample/gpsshell OSL_HOME=/usr/share/libosl-dev OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" FILE_TCMALLOC='' FILE_OSL_ALL='' LDLIBS='-losl -lboost_system -lboost_filesystem -lboost_iostreams -lboost_serialization -ltcmalloc_minimal' RELEASE=t gpsshell
+	$(MAKE) -C sample/gpsshell OSL_HOME=/usr/share/libosl-dev OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" FILE_TCMALLOC='' FILE_OSL_ALL='' LDFLAGS='-Wl,--as-needed' LDLIBS='-losl -lboost_filesystem-mt -lboost_serialization-mt -lboost_iostreams-mt -lboost_system-mt -ltcmalloc_minimal' RELEASE=t gpsshell
 	help2man --section 6 -n "GPSShogi shell like client" --version-string "gpsshell" --no-info \
 	  $(CURDIR)/sample/gpsshell/gpsshell > $(CURDIR)/debian/gpsshell.1
 	# viewer
@@ -72,3 +79,17 @@
 	  rm -rf $(CURDIR)/debian/$$file.1 ; \
 	done
 
+get-orig-source:
+	if [ ! -f gpsshogi.tar.gz ] ; then \
+	  wget -O gpsshogi.tar.gz "http://gps.tanaka.ecc.u-tokyo.ac.jp/cgi-bin/viewvc.cgi/trunk/gpsshogi.tar.gz?root=gpsshogi&view=tar" ; \
+        fi
+	mkdir debian/$(SRCDIR_NAME)
+	cd debian/$(SRCDIR_NAME) && tar xzvf ../../gpsshogi.tar.gz
+	if test "`ls debian/$(SRCDIR_NAME) | wc -l`" -eq "1" ; then \
+	        subdir=`echo debian/$(SRCDIR_NAME)/*` && \
+	        mv $$subdir/* debian/$(SRCDIR_NAME) && \
+	        rmdir $$subdir ; \
+	fi
+	tar czf ../$(SOURCE)_$(ORIG_VERSION).orig.tar.gz -C debian $(SRCDIR_NAME)
+	rm -rf debian/$(SRCDIR_NAME)
+
